clear all;
clc;
Video = VideoReader('pos.AVI');
darkObjValue = 50;
sedisk = strel('disk',2); sesquare = strel('square',5);

nframes = get(Video, 'NumberOfFrames');
Img = read(Video, 1);
taggedH = zeros([size(Img,1) size(Img,2) 3 147], class(Img));

% nframes = 147

for k = 1 : 147
    singleFrame = read(Video, (k+1600));
    Img = rgb2gray(singleFrame);
    mat = zeros(480,640,3,'uint8');
    noDarkCars = imextendedmax(Img, darkObjValue);
    noSmallStructures = imopen(noDarkCars, sedisk);noSmallStructures = imopen(noSmallStructures, sesquare);
    I1 = bwareaopen(noSmallStructures, 450);
    I2 = bwareaopen(I1, 950);
    I = I1-I2;
       
    taggedH(:,:,:,k) = singleFrame;
    stats = regionprops(I, {'Centroid','Area'});
    if ~isempty([stats.Area])
        areaArray = [stats.Area];
        [junk,idx] = max(areaArray);
        c = stats(idx).Centroid;
        c = floor(fliplr(c));
        width = 2;
        row = c(1)-width:c(1)+width;
        col = c(2)-width:c(2)+width;
        taggedH(row,col,1,k) = 255;
        taggedH(row,col,2,k) = 0;
        taggedH(row,col,3,k) = 0;
        x1 = (size(mat,2))/2; y1 = (size(mat,1))/2;
        x = linspace(x1,c(2),1000);  %# x values at a higher resolution
        y = (((c(1) - y1)/(c(2)-x1))*x) - ((c(1)-y1)*c(2)/(c(2)-x1)) + c(1); 
        index = sub2ind(size(mat(:,:,1)),round(y),round(x));  %# Indices of the line
        mat(index) = 255;
        colormap(gray);
    end
    taggedH(:,:,:,k) = taggedH(:,:,:,k) + mat;
end
frameRate = get(Video,'FrameRate');
implay(taggedH,frameRate);


